// ChatCpp.cpp : main project file.

#include "stdafx.h"

#include <iostream>
#include <cstdlib>

const int TEST_COUNT=1; // This is the count of available tests. Check for 
						// new tests at http://konkurs.musala.com/

using namespace System;

int performTest(int testIndex)
{	// This method will execute a single test. This is the trivial solution 
	// of concatenating all words in the order they are in the input and
	// using no macros.
	int index;
	int result; // We will use this to store results from calling service 
				// methods.
	int N; // Count of words.
	int M; // Count of macros.
	cli::array<String ^> ^words;
	// Here we will store words.
	cli::array<String ^> ^macros;
	// Here we will store macros.
	String ^resultString; // Here we will generate the result.
	cli::array<wchar_t> ^letters; 
	// Here we will store the letters for the macros.
	ChatService::Service1 ^ChatServiceObject=gcnew ChatService::Service1();
	// The service object.

	// Perform initialization.
	result=ChatServiceObject->ChatInit(testIndex, N, M, words, letters, macros);
	// Check if initialization was successfull.
	if(result)
	{ // In this case we have error, so we will return it.
		return result;
	}

	// Now generate the solution.
	resultString="";
	for(index=0; index<N; ++index)
	{
		resultString+=words[index];
		resultString+="=";
		for(int j=0; j<words[index]->Length; ++j)
			resultString+="-";
		
	}

	// Now return the solution.
	result=ChatServiceObject->ChatResult(testIndex, resultString);
	
	return result;
}

int main(array<System::String ^> ^args)
{
	int index;

	// Perform all tests
	for(index=1; index<=TEST_COUNT; ++index)
		std::cout<<"Result from test "<<index<<": "<<
			performTest(index)<<std::endl;

	system("pause"); 

	return 0;
}
